import { Component, EventEmitter, OnInit, Output } from '@angular/core';
import { FormBuilder, FormGroup, Validators } from '@angular/forms';
import { Observable } from 'rxjs';
import { Candidate } from 'src/app/shared/models/candidate';
import { CandidateService } from 'src/app/shared/services/candidate.service';

@Component({
  selector: 'app-candidat-search',
  templateUrl: './candidat-search.component.html',
  styleUrls: ['./candidat-search.component.scss']
})
export class CandidatSearchComponent implements OnInit {
  candidates: Observable<Candidate[]>;
  searchForm: FormGroup;
  @Output() public candidatsListResultEvent = new EventEmitter<Observable<Candidate[]>>();
 

  constructor(private formBuilder: FormBuilder,private candidatService: CandidateService) { }

  ngOnInit(): void {
    this.Form();
  }
  private Form() {
    this.searchForm = this.formBuilder.group({
      searchRequest: [""]
    });
  }
  
  search(){
    let SR = this.searchForm.controls['searchRequest'].value;
    this.candidatsListResultEvent.emit(this.candidatService.search(SR))
  }
  
  onSubmit() {
    if (this.searchForm.invalid) {
      alert('Data Error!! :\n\n' + JSON.stringify(this.searchForm.value, null,4));
      return;
    }
    this.search()
  }
}
