import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { CandidatListComponent } from './candidat-list/candidat-list.component';
import { RouterModule, Routes } from '@angular/router';
import { CandidatSearchComponent } from './candidat-search/candidat-search.component';
import { CandidatDetailComponent } from './candidat-detail/candidat-detail.component';
import { CandidatDetailResolver } from 'src/app/shared/resolver/candidat-detail.resolver';
import { ReactiveFormsModule } from '@angular/forms';
import { CandidatSidebarComponent } from './candidat-sidebar/candidat-sidebar.component';
import { NgxPaginationModule } from 'ngx-pagination';
import { NgbModule } from '@ng-bootstrap/ng-bootstrap';
import { CandidatsResolver } from 'src/app/shared/resolver/candidats.resolver';


export const routes: Routes = [
  {
      path: 'candidat/candidat-list',
      component: CandidatListComponent,
      resolve: {
        Candidats: CandidatsResolver 
      },
  },
  {
    path: '/candidat/candidat-detail/:candidatId',
    component: CandidatDetailComponent,
    resolve: {
      candidat: CandidatDetailResolver 
    },
  },
  {
    path: '/candidat/candidat-sidebar',
    component: CandidatSidebarComponent
  }
];

@NgModule({
  declarations: [
    CandidatListComponent,
    CandidatSearchComponent,
    CandidatDetailComponent,
    CandidatSidebarComponent
  ],
  imports: [
    CommonModule,
    RouterModule.forChild(routes),
    ReactiveFormsModule,
    NgxPaginationModule,
    NgbModule
  ],
  exports: [RouterModule]
})
export class CandidatModule { }
