import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { BehaviorSubject, Observable } from 'rxjs';
import { Candidate } from '../models/candidate';

@Injectable({
  providedIn: 'root'
})
export class CandidateService {

  public _candidatsList = new BehaviorSubject<Candidate[]>([]);
  private _candidat = new BehaviorSubject<Candidate>(new Candidate());
  private dataStore:  Candidate[];
  constructor(private http: HttpClient) { }

 candidatGetById(id: string): Observable<Candidate> {
   this.http.get<Candidate[]>('assets/demo/data/candidates.json').subscribe(
           data => 
           { 
             var candidatById = data.filter(i => i.id == id); 
             this._candidat.next(candidatById[0]);
           });
    return this._candidat;
  }

  search(queryS: string): Observable<Candidate[]> {
    this.http.get<Candidate[]>('assets/demo/data/candidates.json').subscribe(
      data => 
      { 
        if(queryS){
          this.dataStore = data.filter(i => (i.firstName.toLowerCase() == queryS.toLowerCase() || i.lastName.toLowerCase() == queryS.toLowerCase() /* || i.emails.find(e => e.email === queryS) */ )); 
          this._candidatsList.next(this.dataStore);
        }
      });
     
    return this._candidatsList;
  }

  getCandidats(): Observable<Candidate[]> {
    this.http.get<Candidate[]>('assets/demo/data/candidates.json').subscribe(
      data => 
      {
        this._candidatsList.next(data);
      }
    );
    return this._candidatsList;
  }
}
